Loading...
Searching...
No Matches
pcl::ModelOutlierRemoval< PointT > Class Template Reference
Module filters

ModelOutlierRemoval filters points in a cloud based on the distance between model and point. More...

`#include <pcl/filters/model_outlier_removal.h>`

Inheritance diagram for pcl::ModelOutlierRemoval< PointT >:

## Public Types

using | PointCloudNPtr = pcl::PointCloud<pcl::Normal>::Ptr
using | PointCloudNConstPtr = pcl::PointCloud<pcl::Normal>::ConstPtr
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | Ptr = shared_ptr<FilterIndices<PointT> >
using | ConstPtr = shared_ptr<const FilterIndices<PointT> >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr<Filter<PointT> >
using | ConstPtr = shared_ptr<const Filter<PointT> >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| ModelOutlierRemoval (bool extract_removed_indices=false)
| Constructor.
void | setModelCoefficients (const pcl::ModelCoefficients &model_coefficients)
| sets the models coefficients
pcl::ModelCoefficients | getModelCoefficients () const
| returns the models coefficients
void | setModelType (pcl::SacModel model)
| Set the type of SAC model used.
pcl::SacModel | getModelType () const
| Get the type of SAC model used.
void | setThreshold (float thresh)
| Set the thresholdfunction.
float | getThreshold () const
| Get the thresholdfunction.
void | setInputNormals (const PointCloudNConstPtr normals_ptr)
| Set the normals cloud.
PointCloudNConstPtr | getInputNormals () const
| Get the normals cloud.
void | setNormalDistanceWeight (const double weight)
| Set the normals distance weight.
double | getNormalDistanceWeight () const
| get the normal distance weight
void | setThresholdFunction (std::function< bool(double)> thresh)
| Register a different threshold function.
template<typename T>
void | setThresholdFunction (bool(T::*thresh_function)(double), T &instance)
| Register a different threshold function.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Types

using | PointCloud = typename FilterIndices<PointT>::PointCloud
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | SampleConsensusModelPtr = typename SampleConsensusModel<PointT>::Ptr

## Protected Member Functions

void | applyFilter (Indices &indices) override
| Filtered results are indexed by an indices array.
void | applyFilterIndices (Indices &indices)
| Filtered results are indexed by an indices array.
bool | checkSingleThreshold (double value)
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

double | normals_distance_weight_
PointCloudNConstPtr | cloud_normals_
SampleConsensusModelPtr | model_
| The model used to calculate distances.
float | thresh_
| The threshold used to separate outliers (removed_indices) from inliers (indices).
Eigen::VectorXf | model_coefficients_
| The model coefficients.
pcl::SacModel | model_type_
| The type of model to use (user given parameter).
std::function< bool(double)> | threshold_function_
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT>
class pcl::ModelOutlierRemoval< PointT >

ModelOutlierRemoval filters points in a cloud based on the distance between model and point.

Iterates through the entire input once, automatically filtering non-finite points and the points outside
Usage example:

pcl::ModelCoefficients model_coeff;
model_coeff.values.resize(4);
model_coeff.values[0] = 0;
model_coeff.values[1] = 0;
model_coeff.values[2] = 1;
model_coeff.values[3] = 0.5;
pcl::ModelOutlierRemoval<pcl::PointXYZ> filter;
filter.setModelCoefficients (model_coeff);
filter.setThreshold (0.1);
filter.setModelType (pcl::SACMODEL_PLANE);
filter.setInputCloud (*cloud_in);
filter.setNegative (false);
filter.filter (*cloud_out);
pcl::FilterIndices::filter
void filter(Indices &indices)
Calls the filtering method and returns the filtered point cloud indices.
Definition filter_indices.h:100
pcl::ModelOutlierRemoval
ModelOutlierRemoval filters points in a cloud based on the distance between model and point.
Definition model_outlier_removal.h:74
pcl::SACMODEL_PLANE
@ SACMODEL_PLANE
Definition model_types.h:47
pcl::ModelCoefficients
Definition ModelCoefficients.h:12
pcl::ModelCoefficients::values
std::vector< float > values
Definition ModelCoefficients.h:17

Definition at line 73 of file model_outlier_removal.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT>

using pcl::ModelOutlierRemoval< PointT >::PointCloud = typename FilterIndices<PointT>::PointCloud

protected

Definition at line 76 of file model_outlier_removal.h.

## PointCloudConstPtr

template<typename PointT>

using pcl::ModelOutlierRemoval< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

protected

Definition at line 78 of file model_outlier_removal.h.

## PointCloudNConstPtr

template<typename PointT>

using pcl::ModelOutlierRemoval< PointT >::PointCloudNConstPtr = pcl::PointCloud<pcl::Normal>::ConstPtr

Definition at line 83 of file model_outlier_removal.h.

## PointCloudNPtr

template<typename PointT>

using pcl::ModelOutlierRemoval< PointT >::PointCloudNPtr = pcl::PointCloud<pcl::Normal>::Ptr

Definition at line 82 of file model_outlier_removal.h.

## PointCloudPtr

template<typename PointT>

using pcl::ModelOutlierRemoval< PointT >::PointCloudPtr = typename PointCloud::Ptr

protected

Definition at line 77 of file model_outlier_removal.h.

## SampleConsensusModelPtr

template<typename PointT>

using pcl::ModelOutlierRemoval< PointT >::SampleConsensusModelPtr = typename SampleConsensusModel<PointT>::Ptr

protected

Definition at line 79 of file model_outlier_removal.h.

## Constructor & Destructor Documentation

## ModelOutlierRemoval()

template<typename PointT>

pcl::ModelOutlierRemoval< PointT >::ModelOutlierRemoval | ( | bool | extract_removed_indices = false | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 89 of file model_outlier_removal.h.

References checkSingleThreshold(), pcl::Filter< PointT >::filter_name_, pcl::FilterIndices< PointT >::FilterIndices(), normals_distance_weight_, setThresholdFunction(), and thresh_.

## Member Function Documentation

## applyFilter()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::applyFilter | ( | Indices & | indices | ) |

inline override protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 211 of file model_outlier_removal.h.

References applyFilterIndices().

## applyFilterIndices()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::applyFilterIndices | ( | Indices & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 145 of file model_outlier_removal.hpp.

References cloud_normals_, pcl::Filter< PointT >::extract_removed_indices_, pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::input_, pcl::isFinite(), model_, model_coefficients_, model_type_, pcl::FilterIndices< PointT >::negative_, normals_distance_weight_, pcl::Filter< PointT >::removed_indices_, and threshold_function_.

Referenced by applyFilter().

## checkSingleThreshold()

template<typename PointT>

bool pcl::ModelOutlierRemoval< PointT >::checkSingleThreshold | ( | double | value | ) |

inline protected

Definition at line 240 of file model_outlier_removal.h.

References thresh_.

Referenced by ModelOutlierRemoval().

## getInputNormals()

template<typename PointT>

PointCloudNConstPtr pcl::ModelOutlierRemoval< PointT >::getInputNormals | ( |  | ) | const

inline

Get the normals cloud.

Definition at line 158 of file model_outlier_removal.h.

References cloud_normals_.

## getModelCoefficients()

template<typename PointT>

pcl::ModelCoefficients pcl::ModelOutlierRemoval< PointT >::getModelCoefficients | ( |  | ) | const

inline

returns the models coefficients

Definition at line 112 of file model_outlier_removal.h.

References model_coefficients_, and pcl::ModelCoefficients::values.

## getModelType()

template<typename PointT>

pcl::SacModel pcl::ModelOutlierRemoval< PointT >::getModelType | ( |  | ) | const

inline

Get the type of SAC model used.

Definition at line 130 of file model_outlier_removal.h.

References model_type_.

## getNormalDistanceWeight()

template<typename PointT>

double pcl::ModelOutlierRemoval< PointT >::getNormalDistanceWeight | ( |  | ) | const

inline

get the normal distance weight

Definition at line 172 of file model_outlier_removal.h.

References normals_distance_weight_.

## getThreshold()

template<typename PointT>

float pcl::ModelOutlierRemoval< PointT >::getThreshold | ( |  | ) | const

inline

Get the thresholdfunction.

Definition at line 144 of file model_outlier_removal.h.

References thresh_.

## setInputNormals()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::setInputNormals | ( | const PointCloudNConstPtr | normals_ptr | ) |

inline

Set the normals cloud.

Definition at line 151 of file model_outlier_removal.h.

References cloud_normals_.

## setModelCoefficients()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::setModelCoefficients | ( | const pcl::ModelCoefficients & | model_coefficients | ) |

inline

sets the models coefficients

Definition at line 100 of file model_outlier_removal.h.

References model_coefficients_, and pcl::ModelCoefficients::values.

## setModelType()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::setModelType | ( | pcl::SacModel | model | ) |

inline

Set the type of SAC model used.

Definition at line 123 of file model_outlier_removal.h.

References model_type_.

## setNormalDistanceWeight()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::setNormalDistanceWeight | ( | const double | weight | ) |

inline

Set the normals distance weight.

Definition at line 165 of file model_outlier_removal.h.

References normals_distance_weight_.

## setThreshold()

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::setThreshold | ( | float | thresh | ) |

inline

Set the thresholdfunction.

Definition at line 137 of file model_outlier_removal.h.

References thresh_.

## setThresholdFunction() [1/2]

template<typename PointT>
template<typename T>

void pcl::ModelOutlierRemoval< PointT >::setThresholdFunction | ( | bool(T::* | thresh_function )(double),
|  | T & | instance )

inline

Register a different threshold function.

Parameters

  [in] | thresh_function | pointer to a threshold function
  [in] | instance |

Definition at line 191 of file model_outlier_removal.h.

References setThresholdFunction().

## setThresholdFunction() [2/2]

template<typename PointT>

void pcl::ModelOutlierRemoval< PointT >::setThresholdFunction | ( | std::function< bool(double)> | thresh | ) |

inline

Register a different threshold function.

Parameters

  [in] | thresh | pointer to a threshold function

Definition at line 181 of file model_outlier_removal.h.

References threshold_function_.

Referenced by ModelOutlierRemoval(), and setThresholdFunction().

## Member Data Documentation

## cloud_normals_

template<typename PointT>

PointCloudNConstPtr pcl::ModelOutlierRemoval< PointT >::cloud_normals_

protected

Definition at line 224 of file model_outlier_removal.h.

Referenced by applyFilterIndices(), getInputNormals(), and setInputNormals().

## model_

template<typename PointT>

SampleConsensusModelPtr pcl::ModelOutlierRemoval< PointT >::model_

protected

The model used to calculate distances.

Definition at line 227 of file model_outlier_removal.h.

Referenced by applyFilterIndices().

## model_coefficients_

template<typename PointT>

Eigen::VectorXf pcl::ModelOutlierRemoval< PointT >::model_coefficients_

protected

The model coefficients.

Definition at line 233 of file model_outlier_removal.h.

Referenced by applyFilterIndices(), getModelCoefficients(), and setModelCoefficients().

## model_type_

template<typename PointT>

pcl::SacModel pcl::ModelOutlierRemoval< PointT >::model_type_

protected

The type of model to use (user given parameter).

Definition at line 236 of file model_outlier_removal.h.

Referenced by applyFilterIndices(), getModelType(), and setModelType().

## normals_distance_weight_

template<typename PointT>

double pcl::ModelOutlierRemoval< PointT >::normals_distance_weight_

protected

Definition at line 223 of file model_outlier_removal.h.

Referenced by applyFilterIndices(), getNormalDistanceWeight(), ModelOutlierRemoval(), and setNormalDistanceWeight().

## thresh_

template<typename PointT>

float pcl::ModelOutlierRemoval< PointT >::thresh_

protected

The threshold used to separate outliers (removed_indices) from inliers (indices).

Definition at line 230 of file model_outlier_removal.h.

Referenced by checkSingleThreshold(), getThreshold(), ModelOutlierRemoval(), and setThreshold().

## threshold_function_

template<typename PointT>

std::function<bool (double)> pcl::ModelOutlierRemoval< PointT >::threshold_function_

protected

Definition at line 237 of file model_outlier_removal.h.

Referenced by applyFilterIndices(), and setThresholdFunction().

The documentation for this class was generated from the following files:

- pcl/filters/model_outlier_removal.h
- pcl/filters/impl/model_outlier_removal.hpp